#version 330 compatibility



/*
 _______ _________ _______  _______  _ 
(  ____ \\__   __/(  ___  )(  ____ )( )
| (    \/   ) (   | (   ) || (    )|| |
| (_____    | |   | |   | || (____)|| |
(_____  )   | |   | |   | ||  _____)| |
      ) |   | |   | |   | || (      (_)
/\____) |   | |   | (___) || )       _ 
\_______)   )_(   (_______)|/       (_)

Do not modify this code until you have read the LICENSE.txt contained in the root directory of this shaderpack!

*/

/////////ADJUSTABLE VARIABLES//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////ADJUSTABLE VARIABLES//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//#define HALF_RES_TRACE

/////////INTERNAL VARIABLES////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////INTERNAL VARIABLES////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Do not change the name of these variables or their type. The Shaders Mod reads these lines and determines values to send to the inner-workings
//of the shaders mod. The shaders mod only reads these lines and doesn't actually know the real value assigned to these variables in GLSL.
//Some of these variables are critical for proper operation. Change at your own risk.

//END OF INTERNAL VARIABLES//




in vec4 texcoord;

in float timeMidnight;

in vec3 colorSunlight;
in vec3 colorSkylight;
in vec3 colorSkyUp;
in vec3 colorTorchlight;

in vec4 skySHR;
in vec4 skySHG;
in vec4 skySHB;


in vec3 worldLightVector;
in vec3 worldSunVector;


in mat4 gbufferPreviousModelViewInverse;
in mat4 gbufferPreviousProjectionInverse;


#include "lib/Uniforms.inc"
#include "lib/Common.inc"

#include "lib/Materials.inc"


/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////






// vec4 GetViewPosition(in vec2 coord, in float depth) 
// {	
// 	vec2 tcoord = coord;
// 	TemporalJitterProjPosInv01(tcoord);

// 	vec4 fragposition = gbufferProjectionInverse * vec4(tcoord.s * 2.0f - 1.0f, tcoord.t * 2.0f - 1.0f, 2.0f * depth - 1.0f, 1.0f);
// 		 fragposition /= fragposition.w;

	
// 	return fragposition;
// }













#include "lib/GBufferData.inc"
 int f(int v)
 {
   return v-FloorToInt(mod(float(v),2.))-0;
 }
 int t(int v)
 {
   return v-FloorToInt(mod(float(v),2.))-1;
 }
 int f()
 {
   ivec2 v=ivec2(viewWidth,viewHeight);
   int y=v.x*v.y;
   return f(FloorToInt(floor(pow(float(y),.333333))));
 }
 int t()
 {
   ivec2 v=ivec2(2048,2048);
   int y=v.x*v.y;
   return t(FloorToInt(floor(pow(float(y),.333333))));
 }
 vec3 v(vec2 v)
 {
   ivec2 s=ivec2(viewWidth,viewHeight);
   int x=s.x*s.y,y=f();
   ivec2 n=ivec2(v.x*s.x,v.y*s.y);
   float z=float(n.y/y),i=float(int(n.x+mod(s.x*z,y))/y);
   i+=floor(s.x*z/y);
   vec3 m=vec3(0.,0.,i);
   m.x=mod(n.x+mod(s.x*z,y),y);
   m.y=mod(n.y,y);
   m.xyz=floor(m.xyz);
   m/=y;
   m.xyz=m.xzy;
   return m;
 }
 vec2 s(vec3 v)
 {
   ivec2 m=ivec2(viewWidth,viewHeight);
   int x=f();
   vec3 i=v.xzy*x;
   i=floor(i+1e-05);
   float y=i.z;
   vec2 n;
   n.x=mod(i.x+y*x,m.x);
   float s=i.x+y*x;
   n.y=i.y+floor(s/m.x)*x;
   n+=.5;
   n/=m;
   return n;
 }
 vec3 d(vec2 v)
 {
   vec2 i=v;
   i.xy/=.5;
   ivec2 s=ivec2(2048,2048);
   int x=s.x*s.y,y=t();
   ivec2 n=ivec2(i.x*s.x,i.y*s.y);
   float z=float(n.y/y),f=float(int(n.x+mod(s.x*z,y))/y);
   f+=floor(s.x*z/y);
   vec3 m=vec3(0.,0.,f);
   m.x=mod(n.x+mod(s.x*z,y),y);
   m.y=mod(n.y,y);
   m.xyz=floor(m.xyz);
   m/=y;
   m.xyz=m.xzy;
   return m;
 }
 vec2 d(vec3 v,int y)
 {
   v=clamp(v,vec3(0.),vec3(1.));
   vec2 m=vec2(2048,2048);
   vec3 i=v.xzy*y;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 n;
   n.x=mod(i.x+x*y,m.x);
   float s=i.x+x*y;
   n.y=i.y+floor(s/m.x)*y;
   n+=.5;
   n/=m;
   n.xy*=.5;
   return n;
 }
 vec3 f(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v=clamp(v,vec3(0.),vec3(1.)),v;
 }
 vec3 s(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v;
 }
 vec3 m(vec3 v)
 {
   int m=t();
   v=v-vec3(.5);
   v*=m;
   return v;
 }
 vec3 x(vec3 v)
 {
   int y=f();
   v*=1./y;
   v=v+vec3(.5);
   v=clamp(v,vec3(0.),vec3(1.));
   return v;
 }
 vec3 e(vec3 v)
 {
   int m=f();
   v=v-vec3(.5);
   v*=m;
   return v;
 }
 vec3 d()
 {
   vec3 v=cameraPosition.xyz+.5,y=previousCameraPosition.xyz+.5,x=floor(v-.0001),i=floor(y-.0001);
   return x-i;
 }
 vec3 n(vec3 v)
 {
   vec4 i=vec4(v,1.);
   i=shadowModelView*i;
   i=shadowProjection*i;
   i/=i.w;
   float x=sqrt(i.x*i.x+i.y*i.y),y=1.f-SHADOW_MAP_BIAS+x*SHADOW_MAP_BIAS;
   i.xy*=.95f/y;
   i.z=mix(i.z,.5,.8);
   i=i*.5f+.5f;
   i.xy*=.5;
   i.xy+=.5;
   return i.xyz;
 }
 vec3 d(vec3 v,vec3 i,vec2 n,vec2 y,vec4 s,vec4 m,inout float x,out vec2 f)
 {
   bool r=fract(v.x*2.)>.01&&fract(v.x*2.)<.99||fract(v.y*2.)>.01&&fract(v.y*2.)<.99||fract(v.z*2.)>.01&&fract(v.z*2.)<.99;
   r=!r;
   if(m.x==8||m.x==9||m.x==79||m.x<1.||!r||m.x==20.||m.x==171.||min(abs(i.x),abs(i.z))>.2)
     x=1.;
   if(m.x==50.||m.x==52.||m.x==76.)
     {
       x=0.;
       if(i.y<.5)
         x=1.;
     }
   if(m.x==51||m.x==53)
     x=0.;
   if(m.x>255)
     x=0.;
   vec3 z,c;
   if(i.x>.5)
     z=vec3(0.,0.,-1.),c=vec3(0.,-1.,0.);
   else
      if(i.x<-.5)
       z=vec3(0.,0.,1.),c=vec3(0.,-1.,0.);
     else
        if(i.y>.5)
         z=vec3(1.,0.,0.),c=vec3(0.,0.,1.);
       else
          if(i.y<-.5)
           z=vec3(1.,0.,0.),c=vec3(0.,0.,-1.);
         else
            if(i.z>.5)
             z=vec3(1.,0.,0.),c=vec3(0.,-1.,0.);
           else
              if(i.z<-.5)
               z=vec3(-1.,0.,0.),c=vec3(0.,-1.,0.);
   f=clamp((n.xy-y.xy)*100000.,vec2(0.),vec2(1.));
   float t=.15,e=.15;
   if(m.x==10.||m.x==11.)
     {
       if(abs(i.y)<.01&&r||i.y>.99)
         t=.1,e=.1,x=0.;
       else
          x=1.;
     }
   if(m.x==51||m.x==53)
     t=.5,e=.1;
   if(m.x==76)
     t=.2,e=.2;
   if(m.x-255.+39.>=103.&&m.x-255.+39.<=113.)
     e=.025,t=.025;
   z=normalize(s.xyz);
   c=normalize(cross(z,i.xyz)*sign(s.w));
   vec3 q=v.xyz+mix(z*t,-z*t,vec3(f.x));
   q.xyz+=mix(c*t,-c*t,vec3(f.y));
   q.xyz-=i.xyz*e;
   return q;
 }struct rXuEJcsNQI{vec3 QbpObHBdUl;vec3 QbpObHBdUlOrigin;vec3 ZRrfSsHfvT;vec3 fgCeZiNBHZ;vec3 ZKdJsVHIyK;vec3 frnQIYJjVJ;};
 rXuEJcsNQI r(Ray v)
 {
   rXuEJcsNQI i;
   i.QbpObHBdUl=floor(v.origin);
   i.QbpObHBdUlOrigin=i.QbpObHBdUl;
   i.ZRrfSsHfvT=abs(vec3(length(v.direction))/(v.direction+1e-07));
   i.fgCeZiNBHZ=sign(v.direction);
   i.ZKdJsVHIyK=(sign(v.direction)*(i.QbpObHBdUl-v.origin)+sign(v.direction)*.5+.5)*i.ZRrfSsHfvT;
   i.frnQIYJjVJ=vec3(0.);
   return i;
 }
 void i(inout rXuEJcsNQI v)
 {
   v.frnQIYJjVJ=step(v.ZKdJsVHIyK.xyz,v.ZKdJsVHIyK.yzx)*step(v.ZKdJsVHIyK.xyz,v.ZKdJsVHIyK.zxy),v.ZKdJsVHIyK+=v.frnQIYJjVJ*v.ZRrfSsHfvT,v.QbpObHBdUl+=v.frnQIYJjVJ*v.fgCeZiNBHZ;
 }
 void d(in Ray v,in vec3 i[2],out float f,out float y)
 {
   float x,z,r,n;
   f=(i[v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   y=(i[1-v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   x=(i[v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   z=(i[1-v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   r=(i[v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   n=(i[1-v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   f=max(max(f,x),r);
   y=min(min(y,z),n);
 }
 vec3 d(const vec3 v,const vec3 y,vec3 m)
 {
   const float x=1e-05;
   vec3 z=(y+v)*.5,i=(y-v)*.5,n=m-z,f=vec3(0.);
   f+=vec3(sign(n.x),0.,0.)*step(abs(abs(n.x)-i.x),x);
   f+=vec3(0.,sign(n.y),0.)*step(abs(abs(n.y)-i.y),x);
   f+=vec3(0.,0.,sign(n.z))*step(abs(abs(n.z)-i.z),x);
   return normalize(f);
 }
 bool e(const vec3 v,const vec3 y,Ray m,out vec2 i)
 {
   vec3 x=m.inv_direction*(v-m.origin),z=m.inv_direction*(y-m.origin),n=min(z,x),s=max(z,x);
   vec2 f=max(n.xx,n.yz);
   float c=max(f.x,f.y);
   f=min(s.xx,s.yz);
   float t=min(f.x,f.y);
   i.x=c;
   i.y=t;
   return t>max(c,0.);
 }
 bool d(const vec3 v,const vec3 i,Ray m,inout float x,inout vec3 y)
 {
   vec3 z=m.inv_direction*(v-1e-05-m.origin),c=m.inv_direction*(i+1e-05-m.origin),n=min(c,z),s=max(c,z);
   vec2 f=max(n.xx,n.yz);
   float t=max(f.x,f.y);
   f=min(s.xx,s.yz);
   float r=min(f.x,f.y);
   bool a=r>max(t,0.)&&max(t,0.)<x;
   if(a)
     y=d(v-1e-05,i+1e-05,m.origin+m.direction*t),x=t;
   return a;
 }
 vec3 e(vec3 v,vec3 i,vec3 y,vec3 x,int z)
 {
   if(rainStrength>.99)
     return vec3(0.);
   v+=1.;
   v-=Fract01(cameraPosition+.5);
   vec3 m=n(v);
   float t=.5;
   vec3 f=vec3(1.)*shadow2DLod(shadowtex0,vec3(m.xy,m.z-.0006*t),2).x;
   f*=saturate(dot(i,y));
   {
     vec4 s=texture2DLod(shadowcolor1,m.xy-vec2(0.,.5),4);
     float c=abs(s.x*256.-(v.y+cameraPosition.y)),r=GetCausticsComposite(v,i,c),e=shadow2DLod(shadowtex0,vec3(m.xy-vec2(0.,.5),m.z+1e-06),4).x;
     f=mix(f,f*r,1.-e);
   }
   f=TintUnderwaterDepth(f);
   return f*(1.-rainStrength);
 }
 vec3 f(vec3 v,vec3 i,vec3 y,vec3 x,int z)
 {
   if(rainStrength>.99)
     return vec3(0.);
   vec3 f=m(v);
   f+=1.;
   f-=Fract01(cameraPosition+.5);
   vec3 s=n(f+y*.99);
   float t=.5;
   vec3 c=vec3(1.)*shadow2DLod(shadowtex0,vec3(s.xy,s.z-.0006*t),3).x;
   c*=saturate(dot(i,y));
   c=TintUnderwaterDepth(c);
   #ifdef GI_SUNLIGHT_STAINED_GLASS_TINT
   float r=shadow2DLod(shadowtex0,vec3(s.xy-vec2(.5,0.),s.z-.0006*t),3).x;
   vec3 e=texture2DLod(shadowcolor,vec2(s.xy-vec2(.5,0.)),3).xyz;
   e*=e;
   c=mix(c,c*e,vec3(1.-r));
   #endif
   return c*(1.-rainStrength);
 }
 vec3 i(vec3 v,vec3 i,vec3 y,vec3 x,int z)
 {
   if(rainStrength>.99)
     return vec3(0.);
   v+=1.;
   v-=Fract01(cameraPosition+.5);
   vec3 m=n(v);
   float t=.5;
   vec3 f=vec3(1.)*shadow2DLod(shadowtex0,vec3(m.xy,m.z-.0006*t),2).x;
   f*=saturate(dot(i,y));
   f=TintUnderwaterDepth(f);
   #ifdef GI_SUNLIGHT_STAINED_GLASS_TINT
   float c=shadow2DLod(shadowtex0,vec3(m.xy-vec2(.5,0.),m.z-.0006*t),3).x;
   vec3 r=texture2DLod(shadowcolor,vec2(m.xy-vec2(.5,0.)),3).xyz;
   r*=r;
   f=mix(f,f*r,vec3(1.-c));
   #endif
   return f*(1.-rainStrength);
 }struct awIafiSlNY{float mwtAZpOIMX;float KZGLOOTLva;float yDFXZDbcEk;float cvVAxIXMRt;vec3 jbwXZaPXmq;};
 vec4 p(awIafiSlNY v)
 {
   vec4 i;
   v.jbwXZaPXmq=max(vec3(0.),v.jbwXZaPXmq);
   i.x=v.mwtAZpOIMX;
   v.jbwXZaPXmq=pow(v.jbwXZaPXmq,vec3(.125));
   i.y=PackTwo16BitTo32Bit(v.jbwXZaPXmq.x,v.yDFXZDbcEk);
   i.z=PackTwo16BitTo32Bit(v.jbwXZaPXmq.y,v.cvVAxIXMRt);
   i.w=PackTwo16BitTo32Bit(v.jbwXZaPXmq.z,v.KZGLOOTLva/255.);
   return i;
 }
 awIafiSlNY h(vec4 v)
 {
   awIafiSlNY i;
   vec2 m=UnpackTwo16BitFrom32Bit(v.y),n=UnpackTwo16BitFrom32Bit(v.z),s=UnpackTwo16BitFrom32Bit(v.w);
   i.mwtAZpOIMX=v.x;
   i.yDFXZDbcEk=m.y;
   i.cvVAxIXMRt=n.y;
   i.KZGLOOTLva=s.y*255.;
   i.jbwXZaPXmq=pow(vec3(m.x,n.x,s.x),vec3(8.));
   return i;
 }
 awIafiSlNY c(vec2 v)
 {
   vec2 x=1./vec2(viewWidth,viewHeight),y=vec2(viewWidth,viewHeight);
   v=(floor(v*y)+.5)*x;
   return h(texture2DLod(colortex5,v,0));
 }
 float c(float v,float y)
 {
   float x=1.;
   #ifdef FULL_RT_REFLECTIONS
   x=clamp(pow(v,.125)+y,0.,1.);
   #else
   x=clamp(v*10.-7.,0.,1.);
   #endif
   return x;
 }
 bool c(vec3 v,float y,Ray i,bool z,inout float x,inout vec3 f)
 {
   bool m=false,r=false;
   #if RAYTRACE_GEOMETRY_QUALITY==0
   if(z)
     return false;
   if(y>=67.)
     return false;
   r=d(v,v+vec3(1.,1.,1.),i,x,f);
   m=r;
   #else
   if(y<40.)
     return r=d(v,v+vec3(1.,1.,1.),i,x,f),r;
   if(y==40.||y==41.||y>=43.&&y<=54.)
     {
       float c=.5;
       if(y==41.)
         c=.9375;
       r=d(v+vec3(0.,0.,0.),v+vec3(1.,c,1.),i,x,f);
       m=m||r;
     }
   if(y==42.||y>=55.&&y<=66.)
     r=d(v+vec3(0.,.5,0.),v+vec3(1.,1.,1.),i,x,f),m=m||r;
   if(y==43.||y==46.||y==47.||y==52.||y==53.||y==54.||y==55.||y==58.||y==59.||y==64.||y==65.||y==66.)
     {
       float c=.5;
       if(y==55.||y==58.||y==59.||y==64.||y==65.||y==66.)
         c=0.;
       r=d(v+vec3(0.,c,0.),v+vec3(.5,.5+c,.5),i,x,f);
       m=m||r;
     }
   if(y==43.||y==45.||y==48.||y==51.||y==53.||y==54.||y==55.||y==57.||y==60.||y==63.||y==65.||y==66.)
     {
       float c=.5;
       if(y==55.||y==57.||y==60.||y==63.||y==65.||y==66.)
         c=0.;
       r=d(v+vec3(.5,c,0.),v+vec3(1.,.5+c,.5),i,x,f);
       m=m||r;
     }
   if(y==44.||y==45.||y==49.||y==51.||y==52.||y==54.||y==56.||y==57.||y==61.||y==63.||y==64.||y==66.)
     {
       float c=.5;
       if(y==56.||y==57.||y==61.||y==63.||y==64.||y==66.)
         c=0.;
       r=d(v+vec3(.5,c,.5),v+vec3(1.,.5+c,1.),i,x,f);
       m=m||r;
     }
   if(y==44.||y==46.||y==50.||y==51.||y==52.||y==53.||y==56.||y==58.||y==62.||y==63.||y==64.||y==65.)
     {
       float c=.5;
       if(y==56.||y==58.||y==62.||y==63.||y==64.||y==65.)
         c=0.;
       r=d(v+vec3(0.,c,.5),v+vec3(.5,.5+c,1.),i,x,f);
       m=m||r;
     }
   if(y>=67.&&y<=82.)
     r=d(v+vec3(6.,0.,6.)/16.,v+vec3(10.,16.,10.)/16.,i,x,f),m=m||r;
   if(y==68.||y==69.||y==70.||y==72.||y==73.||y==74.||y==76.||y==77.||y==78.||y==80.||y==81.||y==82.)
     {
       float c=8.,s=8.;
       if(y==68.||y==70.||y==72.||y==74.||y==76.||y==78.||y==80.||y==82.)
         c=0.;
       if(y==69.||y==70.||y==73.||y==74.||y==77.||y==78.||y==81.||y==82.)
         s=16.;
       r=d(v+vec3(c,6.,7.)/16.,v+vec3(s,9.,9.)/16.,i,x,f);
       m=m||r;
       r=d(v+vec3(c,12.,7.)/16.,v+vec3(s,15.,9.)/16.,i,x,f);
       m=m||r;
     }
   if(y>=71.&&y<=82.)
     {
       float c=8.,t=8.;
       if(y>=71.&&y<=74.||y>=79.&&y<=82.)
         t=16.;
       if(y>=75.&&y<=82.)
         c=0.;
       r=d(v+vec3(7.,6.,c)/16.,v+vec3(9.,9.,t)/16.,i,x,f);
       m=m||r;
       r=d(v+vec3(7.,12.,c)/16.,v+vec3(9.,15.,t)/16.,i,x,f);
       m=m||r;
     }
   #if RAYTRACE_GEOMETRY_QUALITY==2
   if(y>=83.&&y<=86.)
     {
       vec3 c=vec3(0),s=vec3(0);
       if(y==83.)
         c=vec3(0,0,0),s=vec3(16,16,3);
       if(y==84.)
         c=vec3(0,0,13),s=vec3(16,16,16);
       if(y==86.)
         c=vec3(0,0,0),s=vec3(3,16,16);
       if(y==85.)
         c=vec3(13,0,0),s=vec3(16,16,16);
       r=d(v+c/16.,v+s/16.,i,x,f);
       m=m||r;
     }
   if(y>=87.&&y<=102.)
     {
       vec3 c=vec3(0.),s=vec3(1.);
       if(y>=87.&&y<=94.)
         {
           float t=0.;
           if(y>=91.&&y<=94.)
             t=13.;
           c=vec3(0.,t,0.)/16.;
           s=vec3(16.,t+3.,16.)/16.;
         }
       if(y>=95.&&y<=98.)
         {
           float t=13.;
           if(y==97.||y==98.)
             t=0.;
           c=vec3(0.,0.,t)/16.;
           s=vec3(16.,16.,t+3.)/16.;
         }
       if(y>=99.&&y<=102.)
         {
           float t=13.;
           if(y==99.||y==100.)
             t=0.;
           c=vec3(t,0.,0.)/16.;
           s=vec3(t+3.,16.,16.)/16.;
         }
       r=d(v+c,v+s,i,x,f);
       m=m||r;
     }
   if(y>=103.&&y<=113.)
     {
       vec3 c=vec3(0.),s=vec3(1.);
       if(y>=103.&&y<=110.)
         {
           float t=float(y)-float(103.)+1.;
           s.y=t*2./16.;
         }
       if(y==111.)
         s.y=.0625;
       if(y==112.)
         c=vec3(1.,0.,1.)/16.,s=vec3(15.,1.,15.)/16.;
       if(y==113.)
         c=vec3(1.,0.,1.)/16.,s=vec3(15.,.5,15.)/16.;
       r=d(v+c,v+s,i,x,f);
       m=m||r;
     }
   #endif
   #endif
   return m;
 }
 vec3 w(vec2 v)
 {
   vec2 y=vec2(v.xy*vec2(viewWidth,viewHeight));
   y*=1./64.;
   const vec2 i[16]=vec2[16](vec2(-1,-1),vec2(0,-.333333),vec2(-.5,.333333),vec2(.5,-.777778),vec2(-.75,-.111111),vec2(.25,.555556),vec2(-.25,-.555556),vec2(.75,.111111),vec2(-.875,.777778),vec2(.125,-.925926),vec2(-.375,-.259259),vec2(.625,.407407),vec2(-.625,-.703704),vec2(.375,-.037037),vec2(-.125,.62963),vec2(.875,-.481482));
   if(v.x<2./viewWidth||v.x>1.-2./viewWidth||v.y<2./viewHeight||v.y>1.-2./viewHeight)
     ;
   y=(floor(y*64.)+.5)/64.;
   vec3 f=texture2D(noisetex,y).xyz,x=vec3(sqrt(.2),sqrt(2.),1.61803);
   f=mod(f+float(frameCounter%64)*x,vec3(1.));
   return f;
 }
 vec2 y;
 vec3 e(vec3 v,vec2 y)
 {
   y=y*.999+.001;
   float f=6.28319*y.x,x=sqrt(y.y);
   vec3 m=normalize(cross(v,vec3(0.,1.,1.))),c=cross(v,m),i=m*cos(f)*x+c*sin(f)*x+v.xyz*sqrt(1.-y.y);
   return i;
 }
 vec3 h(vec3 v,vec3 y)
 {
   vec2 f=s(x(m(v)+y+1.+d()));
   vec3 i=c(f).jbwXZaPXmq;
   return i;
 }
 vec3 c()
 {
   vec2 i=s(v(y.xy)+d()/f());
   vec3 x=c(i).jbwXZaPXmq;
   return x;
 }
 vec3 c(vec3 v,vec3 m,vec3 x,vec3 s,vec3 z,MaterialMask n,float a,vec2 l,float p,out float G,out vec3 q,float g)
 {
   float Z=fract(frameCounter*.0123456),o=1.;
   #ifdef SUNLIGHT_LEAK_FIX
   if(isEyeInWater<1)
     o=saturate(a*100.);
   #endif
   float J=1.;
   #ifdef CAVE_GI_LEAK_FIX
   if(isEyeInWater<1)
     J=saturate(a*10.);
   #endif
   vec3 R=w(y.xy+vec2(0.,0.)).xyz;
   q=e(x,R.xy);
   G=10000.;
   vec3 K=q;
   #ifdef GI_SCREEN_SPACE_TRACING
   bool b=false;
   {
     const int Y=5;
     float F=.25*-m.z;
     F=mix(F,.8,.5)*.5;
     float D=.07*-m.z;
     D=mix(D,1.,.5);
     D=.6;
     vec2 M=y.xy;
     vec3 T=m.xyz,H=normalize((gbufferModelView*vec4(q.xyz,0.)).xyz);
     for(int S=0;S<Y;S++)
       {
         float C=float(S),k=(C+.5+R.z)/float(Y),X=F*k*k;
         vec3 Q=m.xyz+H*X,P=ProjectBack(Q),U=GetViewPositionNoJitter(P.xy,GetDepth(DownscaleTexcoord(P.xy))).xyz;
         float j=length(Q)-length(U)-.02;
         if(j>0.&&j<D)
           {
             b=true;
             M=P.xy;
             T=U.xyz;
             break;
           }
       }
     vec3 S=(gbufferModelViewInverse*vec4(T,1.)).xyz;
     S+=Fract01(cameraPosition.xyz+.5)+.5;
     if(b)
       {
         vec3 C=pow(texture2DLod(colortex6,M.xy-l*.5,0).xyz,vec3(2.2));
         C*=1.-saturate(p*1.1);
         return C*100.;
       }
   }
   #endif
   const float F=2.4,k=F;
   int S=t();
   float C=1./float(S);
   vec3 D=v+x*(.0002*length(v))-z*(g*.2/(saturate(dot(s,-z))+1e-06)+.005);
   D+=Fract01(cameraPosition.xyz+.5);
   Ray P=MakeRay(f(D,S)*S-vec3(1.,1.,1.),q);
   rXuEJcsNQI T=r(P);
   vec3 M=vec3(1.),Y=vec3(0.);
   float j=0.,H=1.;
   {
     vec4 U=vec4(0.);
     vec3 Q=vec3(0.);
     float X=.5;
     for(int u=0;u<DIFFUSE_TRACE_LENGTH;u++)
       {
         Q=T.QbpObHBdUl/float(S);
         vec2 I=d(Q,S);
         U=texture2DLod(shadowcolor,I,0);
         j=U.w*255.;
         float L=1.-step(.5,abs(j-241.));
         vec3 N=U.xyz*GI_LIGHT_TORCH_INTENSITY;
         Y+=N*L*X*.5;
         #ifdef GI_LEAF_TRANSPARENCY
         if(abs(j-36.)<.1)
           {
             if(R.z<pow(.5,H))
               {
                 i(T);
                 X=1.;
                 H+=10.;
                 M*=pow(U.xyz,vec3(.25));
                 continue;
               }
           }
         #endif
         if(j<240.)
           {
             if(c(T.QbpObHBdUl,j,P,u==0,G,K))
               {
                 break;
               }
           }
         i(T);
         X=1.;
       }
     float u=0.;
     if(j<1.f||j>254.f)
       {
         vec3 I=P.direction;
         if(isEyeInWater>0)
           I=refract(I,vec3(0.,-1.,0.),1.3333);
         vec3 N=SkyShading(I,worldSunVector,rainStrength);
         N*=saturate(I.y*10.+1.);
         N=DoNightEyeAtNight(N*12.,timeMidnight)*.083333;
         if(length(I)<.1)
           u=300.;
         vec3 L=N*J*M,E=L;
         #ifdef CLOUDS_IN_GI
         CloudPlane(E,-P.direction,worldLightVector,worldSunVector,colorSunlight,colorSkyUp,L,timeMidnight,false);
         L=mix(L,E,vec3(o*J));
         #endif
         L=TintUnderwaterDepth(L);
         L*=saturate(I.y*5.);
         Y+=L*.1;
       }
     else
       {
         if(abs(j-31.)<.1)
           Y+=.09*M*U.xyz*GI_LIGHT_BLOCK_INTENSITY;
         if(j>=32.&&j<=35.)
           {
             float L=0.;
             if(abs(j-32.)<.1)
               L=max(-K.z,0.);
             if(abs(j-33.)<.1)
               L=max(K.x,0.);
             if(abs(j-34.)<.1)
               L=max(K.z,0.);
             if(abs(j-35.)<.1)
               L=max(-K.x,0.);
             Y+=.02*M*L*vec3(2.,.35,.025)*GI_LIGHT_BLOCK_INTENSITY;
           }
         if(j<240.)
           {
             vec3 L=saturate(U.xyz);
             M*=L;
             Y+=h(Q,K)*M*k;
             vec3 I=i(D+P.direction*G-1.,worldLightVector,K,q,S),N=DoNightEyeAtNight(I*M*F*colorSunlight*o*J*12.,timeMidnight)/12.;
             Y+=N;
             u=G;
           }
       }
     if(isEyeInWater>0)
       UnderwaterFog(Y,u,q,colorSkyUp,colorSunlight);
   }
   return Y;
 }
 void main()
 {
   vec4 v=texture2DLod(colortex2,texcoord.xy,0),i=texture2DLod(colortex7,texcoord.xy,0);
   y=texcoord.xy;
   if(y.x<HalfScreen.x&&y.y>HalfScreen.y)
     {
       y-=vec2(0.,HalfScreen.y);
       GBufferData m=GetGBufferData(y.xy);
       MaterialMask x=CalculateMasks(m.materialID,y.xy);
       vec4 s=GetViewPosition(y.xy,m.depth),f=gbufferModelViewInverse*vec4(s.xyz,1.),n=gbufferModelViewInverse*vec4(s.xyz,0.);
       vec3 t=normalize(s.xyz),r=normalize(n.xyz),z=normalize((gbufferModelViewInverse*vec4(m.normal,0.)).xyz),e=normalize((gbufferModelViewInverse*vec4(m.geoNormal,0.)).xyz);
       float L=length(s.xyz),o=dot(m.mcLightmap.xy,vec2(.5));
       if(x.grass>.5)
         z=vec3(0.,1.,0.),e=vec3(0.,1.,0.);
       float a;
       vec3 j,I=c(f.xyz,s.xyz,z.xyz,e,r.xyz,x,m.mcLightmap.y,vec2(0.),0.,a,j,m.parallaxOffset);
       v=vec4(j*.5+.5,1.);
       i=vec4(I,saturate(a*.1));
     }
   gl_FragData[0]=texture2DLod(colortex1,texcoord.xy,0);
   gl_FragData[1]=vec4(v);
   gl_FragData[2]=vec4(i);
 };




/* DRAWBUFFERS:127 */
